#include <stdio.h>
#include <vector>
#include <map>

using namespace std;

int max(int a, int b) { return (a>b)?a:b; }
/*
void dump(const char* pref, vector<int>& asd) {
	//printf("%s.size(): %d\n",pref,asd.size());
	for(int i=0; i<asd.size(); ++i) {
		//printf("%s: %d\n",pref,asd[i]);
	}
}*/

int main() {
    int M; //szamok szama
    int Q; //intervallumok szama
    while(true) {
        scanf("%d %d",&M, &Q);
        if(!M && !Q)
            break;
        vector<int> raw;
        for(int i=0; i<M; ++i) {
            int tmp=0;
            scanf("%d",&tmp);
            raw.push_back(tmp);
        }
        
       	int target = 1;
       	while(target<M)
       		target<<=1;
       		
       	for(int i=M; i<target; ++i)
       		raw.push_back(-1);
       	M=target;
       	
        map<int,int> last;
        vector<vector<int> > maxTree;
        maxTree.push_back(vector<int>());
        vector<int>& X = maxTree[0];
        for(int i=0; i<M; ++i) {
            map<int,int>::iterator it = last.find(raw[i]);
            if(it == last.end()) {
                last[raw[i]] = -1;
            }
            X.push_back(last[raw[i]] + 1);
            last[raw[i]] = i;
        }
        
        int l = M;
        while(l!=1) {
            l=l/2;
            maxTree.push_back(vector<int>());
            vector<int>& after = maxTree[maxTree.size()-1];
            vector<int>& before = maxTree[maxTree.size()-2];
		    //dump("maxTree[maxTree.size()-2]",maxTree[maxTree.size()-2]);
		    //dump("before",before);
            int k = before.size();
            for(int i=0; i<k/2; ++i) {
                after.push_back(max(before[2*i],before[2*i+1]));
            }
            if(k%2)
                after.push_back(before[k-1]);
        }
        
        int mSize = maxTree.size();
        for(int i=0; i<Q; ++i) {
            int a, b;
            int ax=0;
            int bx=0;
            int ay=M;
            int by=M;
            int m = -1;
            //printf("%d: %d\n",__LINE__,m);
            int apos = 0;
            int bpos = 0;
            //printf("%d bpos %d\n",__LINE__,bpos);
            scanf("%d %d",&a,&b);
            --a; --b;
        	////printf("QUERY: %d %d\n",a,b);
            
            int start=mSize-1;
            for(int j=mSize-1; j>0; --j) {
            	int z=(ay+ax)/2;
            	if(a<z && b<z) {
            		ay = z;
            		apos = 2*apos;
            	} else if(a>=z && b>=z) {
            		ax = z;
            		apos = 2*apos+1;
            	} else {
            		start=j;
            		by=ay;
            		ay = bx = z;
            		apos = 2*apos;
            		bpos = apos+1;
		            //printf("%d bpos %d\n",__LINE__,bpos);
            		break;
        		}
                //printf("(c)pos: %d\n",apos);
                //printf("(c)level: %d, size: %d\n",j-1,maxTree[j-1].size());
                //printf("(c)x: %d, y: %d\n",ax,ay);
            }
            
            //printf("(q)Apos: %d\n",apos);
            //printf("(q)Bpos: %d\n",bpos);
            //printf("(q)level: %d, size: %d\n",start-1,maxTree[start-1].size());
            //printf("(q)ax: %d, ay: %d\n",ax,ay);         
            //printf("(q)bx: %d, by: %d\n",bx,by);         
                        
            for(int j=start-1; j>0; --j) {
                int z=(ay+ax)/2;
                if(a<z) {
                    ay = z;
                    //if(2*apos+1 < (int)maxTree[j-1].size())
                    m = max(maxTree[j-1][2*apos+1],m);
           			//printf("%d: %d\n",__LINE__,m);
                    apos = 2*apos;
                } else {
                    ax = z;
                    apos = 2*apos+1;
                }
                ////printf("(a)pos: %d\n",apos);
                ////printf("(a)m: %d\n",m);
                ////printf("(b)level: %d, size: %d\n",j-1,maxTree[j-1].size());
                ////printf("(a)x: %d, y: %d\n",ax,ay);
            }
            m = max(maxTree[0][apos],m);
            //printf("%d: %d\n",__LINE__,m);
            
            for(int j=start-1; j>0; --j) {
                int z=(by+bx)/2;
                if(b>=z) {
                    bx = z;
                    m = max(maxTree[j-1][2*bpos],m);
		            //printf("%d: %d\n",__LINE__,m);
                    bpos = 2*bpos+1;
		            //printf("%d bpos %d\n",__LINE__,bpos);
                } else {
                	by = z;
                	bpos = 2*bpos;
		            //printf("%d bpos %d\n",__LINE__,bpos);
                }
                //printf("(b)pos: %d\n",bpos);
                //printf("(b)m: %d\n",m);
                //printf("(b)level: %d, size: %d\n",j-1,maxTree[j-1].size());
                //printf("(b)x: %d, y: %d\n",bx,by);
            }
            //printf("bpos at %d: %d\n",__LINE__,bpos);
            //printf("M: %d\n",M);
            m = max(maxTree[0][bpos],m);
            //printf("%d: %d\n",__LINE__,m);
            ////printf("m: %d\n",m);
            //printf("m: %d\n",m);
			if(m>a)
				printf("%d\n",raw[m-1]);
			else
				printf("OK\n");
        }
        printf("\n");
    }
    return 0;
}
